package com.gigachatwoot.connectors.chatwoot.mapper;


import com.gigachatwoot.connectors.chatwoot.models.ChatwootWebhookPayload;
import com.gigachatwoot.connectors.chatwoot.dto.ChatwootWebhookPayloadDTO;

public class ChatwootWebhookPayloadMapper {

    public static ChatwootWebhookPayloadDTO toDTO(ChatwootWebhookPayload payload) {
        String event = payload.getEvent();
        Long accountId = payload.getAccount().getId();
        String accountName = payload.getAccount().getName();
        String content = payload.getContent();
        Long conversationId = payload.getConversation().getId();
        String messageType = payload.getMessageType();

        return new ChatwootWebhookPayloadDTO(event, accountId, accountName, content, conversationId, messageType);
    }
}
