package com.gigachatwoot.connectors.llm.controllers;

import com.fasterxml.jackson.databind.JsonNode;
import com.gigachatwoot.connectors.chatwoot.models.ChatMessage;
import com.gigachatwoot.connectors.llm.dto.GigaChatAuthDTO;
import com.gigachatwoot.connectors.llm.dto.GigaChatRequestDTO;
import com.gigachatwoot.connectors.llm.mapper.UnirestMapper;
import com.gigachatwoot.connectors.llm.models.GigaChatAuthRequestModel;
import com.gigachatwoot.connectors.llm.models.GigaChatMessageRequestModel;
import jakarta.validation.constraints.NotNull;
import kong.unirest.HttpResponse;
import kong.unirest.Unirest;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.web.bind.annotation.PostMapping;// Add something here when it's necessary to make inner requests.
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

import static org.springframework.http.MediaType.APPLICATION_FORM_URLENCODED_VALUE;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;

@Slf4j
@RestController
@RequiredArgsConstructor
@PropertySource("classpath:application.yml")
@RequestMapping("/api/v1") // http://127.0.0.1/api/v1
public class GigaChatController {
//
//    @PostMapping("/get-llm-answer") // http://localhost:5000/api/v1/get-llm-answer
//    public String getGigaChatAnswer() {
//        String accessTokenResponse = getAccessToken();
//        List<ChatMessage> messageHistory = new ArrayList<>();
//        ChatMessage.Sender sender = new ChatMessage.Sender();
//        sender.setType("user");
//
//        ChatMessage testMsg = new ChatMessage();
//        testMsg.setId(1L);
//        testMsg.setContent("Привет как дела");
//        testMsg.setMessageType(0L);
//        testMsg.setSender(sender);
//        messageHistory.add(testMsg);
//
//        HttpResponse<String> response = Unirest.post(getChatUrl())
//            .header("Content-Type", APPLICATION_JSON_VALUE)
//            .header("Accept", APPLICATION_JSON_VALUE)
//            .header("Authorization", "Bearer " + accessTokenResponse)
//            .body(messageToString(msgRequest.getSystemPrompt(), messageHistory))
//            .asString();
//
//        return parseLLMContent(
//            objectMapper.readValue(response.getBody(), JsonNode.class)
//        );
//    }


//
//    private final UnirestMapper objectMapper;
//
//    @PostMapping
//
////-----------------
//    public String getLLaMaAnswer() {
//        // TODO: Make the value dynamic by implementing to the ChatWoot connector.
//        String testMsg = "Как оформить развод если нахожусь в зоне сво";
//
//        HttpResponse<String> response = Unirest.post(service.getChatUrl())
//            .header("Content-Type", msgRequest.getContentType())
////            .header("Accept", msgRequest.getAccept())
////            .header("Authorization", authToken)
////            .body("{\"model\":\"llama3\", \"messages\":[{\"role\":\"user\", \"content\": testMsg }], \"stream\": \"false\"}")
//            .body(service.messageToString(msgRequest.getSystemPrompt(), testMsg))
//            .field("model", "llama3")
////            .field("messages")
//            .asString();

////------------------
//
//
//            JSONObject requestBody = new JSONObject();
//            requestBody.put("model", "llama3");
//
//            JSONArray messages = new JSONArray();
//            JSONObject message = new JSONObject();
//            message.put("role", "user");
//            message.put("content", testMsg);
//            messages.put(message);
//
//            requestBody.put("messages", messages);
//            requestBody.put("stream", false);
//
//            HttpResponse<String> response = Unirest.post("http://localhost:11434/api/chat")
//                    .header("Content-Type", "application/json")
//                    .body(requestBody)
//                    .asString();
//
//        return parseLLMContent(objectMapper.readValue(response.getBody(), JsonNode.class));
//

//    public class PostRequestExample {
//    public static void main(String[] args) {
//        Unirest unirest = Unirest.post("http://localhost:11434/api/chat")
//        JsonNode jsonBody = new JsonNode()
//            .put("model", "llama3")
//            .childArray().add(new JsonNode()
//                .put("role", "user")
//                .put("content", testMsg))
//        unirest.body(jsonBody);
//        unirest.asJson();
//        HttpResponse<JsonNode> response = unirest.execute();
//    }


//        HttpResponse<String> response_llama = Unirest.post("http://localhost:11434/api/chat")
//            .header("Content-Type", msgRequest.getContentType())
//            .queryString("apiKey", "123")
//            .body()
//      .field("parameter", "value")
//      .field("firstname", "Gary")
//      .asString();
//    }
}
