package com.gigachatwoot.connectors.llm.controllers;

import com.gigachatwoot.connectors.llm.services.LLMConnectorService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.PropertySource;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@RequiredArgsConstructor
@PropertySource("classpath:application.yml")
@RequestMapping("/api/v1") // http://127.0.0.1/api/v1
public class LLMController {
    private LLMConnectorService llmConnectorService;

    @PostMapping("/get-llm-answer")
    public String getLLMAnswer() {
        return llmConnectorService.getLLMAnswer();
    }
}
