package com.gigachatwoot.connectors.llm.models;

import jakarta.validation.constraints.NotNull;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

@Getter
@Setter(AccessLevel.NONE)
@Component
@PropertySource("classpath:application.yml")
public class GigaChatMessageRequestModel {
    @Value("${gigachat.system_prompt}")
    @NotNull(message = "System prompt is required.")
    private String systemPrompt;
}
